#Compile Exe
#Dim All

Global addAlias As Long
Global className As String
Global interfaceName As String
Global arbitrary As Long
Global arbitraryId As Long

Function PBMain () As Long
	Local i As Long
	Local cmd As String
	Local filename As String
	Local v As String
	Local p As Long
	Local q As Long
	Local n As String
	Local t As String

	i = 1
	While Command$(i)<>""
		cmd = LCase$(Command$(i))
		If Left$(cmd,1)="-" Then Mid$(cmd,1,1)="/"
		If Left$(cmd,1)="/" Then
			Select Case cmd
				Case "/add": addAlias = -1
				Case "/remove": addAlias = 0
				Case "/arbitrary": arbitrary = -1
				Case Else
					Exit Function
			End Select
		End If
		Incr i
	Wend
	Shell "cmd /C Dir *.bas;*.inc /b /s >filelist.tmp"
	Open "filelist.tmp" For Input As #1

	While Not Eof(1)
		Line Input #1, filename
		If Trim$(filename)<>"" Then
			Open filename For Input As #2
			Open "tmp.txt" For Output As #3
			className = ""
			interfaceName = "cm"
			While Not Eof(2)
				Line Input #2, v
				Call ParseName( v, n, t )
				Select Case t
					Case "class"
						className = n
						interfaceName = "cm"
					Case "interface"
						interfaceName = n
					Case "method"
						p = InStr(v, "(" )
						q = InStr( LCase$(v), " alias " )
						If p>0 Then
							If addAlias Then
								If q=0 Then
									v = Left$(v, p-1) + GetAlias( n, t ) + Mid$(v, p)
								End If
							Else
								If q>0 Then
									v = Left$(v, q-1) + Mid$(v, p)
								End If
							End If
						End If
					Case "get","set"
						p = InStr(v, "(" )
						q = InStr( LCase$(v), " alias " )
						If p>0 Then
							If addAlias Then
								If q = 0 Then
									v = Left$(v, p-1) + GetAlias( n, t ) + Mid$(v, p)
									'v = Left$(v, p-1) + Build$(" Alias ",$Dq, className, "_", interfaceName, "_", t, "_", n, $Dq, " ") + Mid$(v, p)
								End If
							Else
								If q>0 Then
									v = Left$(v, q-1) + Mid$(v, p)
								End If
							End If
						End If
				End Select
				Print #3, v
			Wend
			Close #3
			Close #2
			Kill filename
			Name "tmp.txt" As filename
		End If
	 Wend
	 Close #1
	 Kill "filename.tmp"
End Function

Function GetAlias( n As String, acc As String ) As String
	Local nm As String
	Local idName As String

	If arbitrary Then
		Incr arbitraryId
		idName = "_" + Format$( arbitraryId, "0" )
		nm = Build$(n, "_" )
		If acc<>"method" Then
			' Get or Set
			nm = Build$( nm, acc, "_" )
		End If
		nm = Build$(nm, interfaceName, "_", className  )
		If Len( nm ) + Len(idName) > 32 Then
			nm = Left$( nm, 32 - Len(idName) )
			nm += idName
		End If
		nm = Build$( " Alias ", $Dq, nm, $Dq, " " )
	Else
		nm = Build$(" Alias ",$Dq, className, "_", interfaceName, "_", n, $Dq, " ")
	End If
	Function = nm
End Function

Sub ParseName( value As String, n As String, t As String )
	Local v As String
	Local p As Long
	Local cnt As Long

	v = value
	Replace $Tab With " " In v
	Replace "(" With " (" In v
	Replace "  " With " " In v
	v = Trim$(v)
	cnt = ParseCount( v, " ")
	Dim l(cnt-1) As String
	Parse v, l(), " "
	t = ""
	n = ""
	If LCase$(l(0)) = "interface" Then
		n = l(1)
		t = "interface"
	ElseIf LCase$(l(0)) = "class" And LCase$(l(1))<>"method" Then
		n = l(1)
		t = "class"
	ElseIf LCase$(l(0)) = "class" And LCase$(l(1))="method" Then
		n = l(2)
		t = "method"
	ElseIf LCase$(l(0)) = "property" And LCase$(l(1)) = "get" Then
		n = l(2)
		t = "get"
	ElseIf LCase$(l(0)) = "property" And LCase$(l(1)) = "set" Then
		n = l(2)
		t = "set"
	ElseIf LCase$(l(0)) = "method" And Mid$(l(1),1,1)<>"=" Then
		n = l(1)
		t = "method"
	End If
	If n<>"" Then
		p = InStr(n, "(")
		If p>0 Then
			n = Left$(n, p-1 )
		End If
	End If
End Sub
